# Restructer

> The restructer library is a type-safe encoder/decoder up to one level for objects.

The library is a type-safe encoder/decoder for converting data with all types available, the output string is fully database safe (Tested with Redis/MySQL).
This library fixed an issue for me where I had an instance of an object, that when I encoded I needed to keep ALL data types in-tact including, null, undefined, etc. The library is influenced by the PHP serialize/unserialize functions.

### Notes

* This library was built to solve my immediate problem, so it is only one level deep, meaning it will convert an object, of key, values but not an object of object of key values, otherwise it will fall back to JSON.stringify.
* I do plan to make this work all the way down the object tree, but I am putting it out there in case anyone else needs something similar.
* Any ideas, then please create an issue, I would absolutely be happy to take a look at them and if possible implement them.
* This library is built very small, if you have any ideas or even changes you wish to implement yourself just send a MR/PR.

### Installation

You can install the library using the following

```
npm install restructer
```

### Usage

```javascript
// Instantiate the library
const restructer = require('restructer');

// Have the object you wish to re-construct
const myObject = {
	name: 'John Doe',
	age: 32,
	hasJob: false,
	jobTitle: null,
}

// Convert to string
const myObjectStr = restructer.encode(myObject);
console.log(myObjectStr);

// Convert back from string
const myObjectStrObject = restructer.decode(myObjectStr);
console.log(myObjectStrObject);
```

### Examples

There is on example which is just the above code in a file, under `example.js`.